<template>
  <v-row>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Rank" rules="required|integer|between:1,100" v-model="rank.rank">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Ordre de classement" density="compact"
          data-cy="RankFormRankInput" :error-messages="errors" type="number" variant="outlined" class="required" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Name" rules="required|max:10" v-model="rank.name">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Grade" density="compact"
          data-cy="RankFormNameInput" :error-messages="errors" :counter="10" variant="outlined" class="required" color="primary" persistentCounter>
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Category" rules="required" v-model="rank.category">
        <v-select @update:model-value="field.onChange" :model-value="value" label="Armée / Catégorie" density="compact"
          data-cy="RankFormCategoryInput" :error-messages="errors" :items="rankCategories" variant="outlined" color="primary" class="required">
        </v-select>
      </Field>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { RankCategory } from "~/dto/rankcategory.enum";
import { Rank } from "~/dto/rank.dto";

const props = defineProps<{ rank: Rank }>();

const rankCategories = Object.values(RankCategory).filter(value => typeof value === 'string');

</script>
